-- ATE Tool database upgrade script 
-- From version     : 1.4.0
-- To version       : 1.5.0
-- Target DB engine : MySQL 5.1.x
--
-- added tables :
--    `OrganizationUnit`
--    `ProjectCharter`
--    `ProjectCharterBudgetHistory`
--    `ProjectCharterBudget`
--    `ProjectCharterFileHistory`
--    `Subcontractor`
--    `ProjectCharterApprover`
--
-- added column :
--    `OrganizationUnit_ID` to table `Person`
--    `CostCenter_ID to table `Person`
--


DROP TABLE IF EXISTS `Subcontractor`;
CREATE TABLE `Subcontractor` (
  `Subcontractor_ID` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(70) COLLATE utf8_unicode_ci NOT NULL,
  `Short` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`Subcontractor_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `Subcontractor` (`Subcontractor_ID`, `Name`, `Short`) VALUES
(1, 'Albuquerque NM', 'ABQ'),
(2, 'Yeovil', 'AYE'),
(3, 'Beijing', 'BEI'),
(4, 'Bulgaria', 'BGR'),
(5, 'Bangalore', 'BLR'),
(6, 'Romania', 'BUC'),
(7, 'Deer Valley', 'DEE'),
(8, 'Mike Trego', 'ESS'),
(9, 'Glendale', 'GLE'),
(10, 'Olomouc', 'HAO'),
(11, 'Hyderabad', 'HDR'),
(12, 'HTS', 'HTS'),
(13, 'Aero Golden Valley', 'MIN'),
(14, 'Olathe', 'OLA'),
(15, 'Phoenix', 'PHX'),
(16, 'Coon Rapids', 'RAP'),
(17, 'Redmond', 'RED'),
(18, 'Tewkesbury', 'TEW'),
(19, 'Toulouse', 'TLS'),
(20, 'Tucson', 'TUC'),
(21, 'Wichita', 'WIC'),
(22, 'External', 'EXT');

--
-- Adding data for table `Responsibility`
--

INSERT INTO `Responsibility` (`Responsibility_ID`, `Name`) VALUES
(18, 'Others');

--
-- Adding data for table `Person`
--

INSERT INTO `Person` (`EID`, `Surname`, `Name`, `CostCenter`) VALUES
('ENN0000', 'SBE unit', 'Virtual leader', 'EEEPZZA1'),
('E456523', 'Marche', 'Stephane', 'EEEPZZA1');


DROP TABLE IF EXISTS `OrganizationUnit`;
CREATE TABLE `OrganizationUnit` (
  `OrganizationUnit_ID` int(11) NOT NULL AUTO_INCREMENT,
  `Parent_ID` int(11) NOT NULL,
  `Leader` varchar(7) COLLATE utf8_unicode_ci NOT NULL,
  `Type` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `Short` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
  `Path` varchar(30) COLLATE utf8_unicode_ci DEFAULT NULL,
  `CostCenter_ID` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`OrganizationUnit_ID`),
  KEY `OrganizationUnit_fk` (`Leader`),
  KEY `OrganizationUnit_fk1` (`Parent_ID`),
  KEY `OrganizationUnit_fk2` (`CostCenter_ID`),
  CONSTRAINT `OrganizationUnit_fk` FOREIGN KEY (`Leader`) REFERENCES `Person` (`EID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `OrganizationUnit_fk1` FOREIGN KEY (`Parent_ID`) REFERENCES `OrganizationUnit` (`OrganizationUnit_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `OrganizationUnit_fk2` FOREIGN KEY (`CostCenter_ID`) REFERENCES `CostCenter` (`CostCenter_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Data for table `Organization Unit`
--

INSERT INTO `OrganizationUnit` (`Parent_ID`, `Leader`, `Type`, `Name`, `Short`, `Path`) VALUES

('1', 'ENN0000', 'SBE', 'Advanced Technology Europe', 'ATE', ''),
('2', 'ENN0000', 'SBE', 'Honeywell Olomouc', 'HAO', ''),
('3', 'ENN0000', 'SBE', 'Defense & Space', 'D&S', ''),
('4', 'ENN0000', 'SBE', 'ASIC', 'ASIC', ''),
('5', 'ENN0000', 'SBE', 'Guest', 'Guest', ''),

('1', 'E410694', 'DEP', 'Mechanical & Simulation Technologies', 'MST', ''),
('1', 'E150630', 'DEP', 'Electronic Technologies', 'ET', ''),
('1', 'E408191', 'DEP', 'Programs/External Customers', 'PEC', ''),
('1', 'E164534', 'DEP', 'System Engineering & Applications', 'SEA', ''),
('1', 'E456523', 'DEP', 'Architects', 'ARCH', ''),
('1', 'E445090', 'DEP', 'Operations', 'OPS', ''),

('6', 'E410694', 'CLUS', 'Mechanical Technologies', 'MT', ''),
('6', 'E415887', 'CLUS', 'Modeling & Mockup & Simulation', 'MMS', ''),
('7', 'E816085', 'CLUS', 'Navigation & Sensors', 'NAV', ''),
('7', 'E807315', 'CLUS', 'Platform Systems, Displays & Electric Aircraft Comp', 'PDP', ''),
('7', 'E544562', 'CLUS', 'Communication & Surveillance', 'COM', ''),
('9', 'E164534', 'CLUS', 'Power Mgmt Systems & Ground Surveillance Applications', 'PWM', ''),
('9', 'E337992', 'CLUS', 'Human Factors, ATM Svcs & Precision Guidance', 'HFP', ''),
('9', 'E329005', 'CLUS', 'Trajectory Mgmt & Surveillance Applications', 'TMS', ''),
('11', 'E445090', 'CLUS', 'Functional Support & Processes', 'FSP', ''),
('11', 'E483649', 'CLUS', 'Project Management Office', 'PMO', ''),

('12', 'E351640', 'TG', 'CBM/SHM', '', ''),
('12', 'E398560', 'TG', 'Material & Processes', '', ''),
('13', 'E419163', 'TG', 'Software Prototyping & Mockups', '', ''),
('13', 'E415887', 'TG', 'Modeling & Simulations', '', ''),
('14', 'E315195', 'TG', 'Satellite Navigation', '', ''),
('14', 'E445088', 'TG', 'Navigation & Tracking & Image Processing', '', ''),
('14', 'E445088', 'TG', 'Sensors', '', ''),
('15', 'E480475', 'TG', 'Platform systems', '', ''),
('15', 'E807315', 'TG', 'Displays & Graphics', '', ''),
('15', 'E807315', 'TG', 'Power & Controls', '', ''),
('15', 'E807315', 'TG', 'Micro Electronics', '', ''),
('16', 'E544562', 'TG', 'Radio Communication', '', ''),
('16', 'E544562', 'TG', 'Connected Aircraft', '', ''),
('16', 'E544562', 'TG', 'Surveillance & Radar', '', ''),
('17', 'E164534', 'TG', 'Power Mgmt Systems', '', ''),
('17', 'E329005', 'TG', 'Ground Surveillance Applications', '', ''),
('18', 'E334632', 'TG', 'Human Centered Systems', '', ''),
('18', 'E812649', 'TG', 'Datalink & Flight Operations Services', '', ''),
('18', 'E450710', 'TG', 'Precision guidance', '', ''),
('19', 'E312284', 'TG', 'Surveillance Applications', '', ''),
('19', 'E338000', 'TG', 'Trajectory Management', '', ''),
('20', 'E445090', 'TG', 'Administration', '', ''),
('20', 'E445090', 'TG', 'Procurement', '', ''),
('20', 'E445090', 'TG', 'Finance', '', ''),

('2', 'ENN0000', 'TG', 'HAO Material & Process Eng', 'HAO MPE', ''),
('2', 'ENN0000', 'TG', 'HAO Mech Systems, Structures & Dynamics', 'HAO MSSD', ''),
('2', 'ENN0000', 'TG', 'HAO Mechanical Design', 'HAO MD', ''),
('2', 'ENN0000', 'TG', 'HAO Mechanical ISC Support', 'HAO MIS', ''),
('2', 'ENN0000', 'TG', 'HAO Rot. Comp, Comb. Systems & Methods', 'HAO RCCSM', ''),

('3', 'ENN0000', 'TG', 'D&S PP&C', 'D&S PP&C', ''),
('3', 'ENN0000', 'TG', 'D&S EHCOE - Component Eng', 'D&S CE', ''),
('3', 'ENN0000', 'TG', 'D&S ASIC Brno - Budzinski', 'D&S ASIC', ''),
('3', 'ENN0000', 'TG', 'D&S EHCOE - Electrical Design', 'D&S ED', ''),
('3', 'ENN0000', 'TG', 'D&S EPC - Electrical/Mechanical', 'D&S EM', ''),
('3', 'ENN0000', 'TG', 'D&S EHCOE - Power Supply/EMI', 'D&S PSE', ''),
('3', 'ENN0000', 'TG', 'D&S EHCOE - Board Layout', 'D&S BL', ''),
('3', 'ENN0000', 'TG', 'D&S EHCOE - Mechanical Design', 'D&S MD', ''),
('3', 'ENN0000', 'TG', 'D&S PI - PA&C', 'D&S PA&C', ''),
('3', 'ENN0000', 'TG', 'D&S PIPA Certification', 'D&S PIPA', ''),
('3', 'ENN0000', 'TG', 'D&S ETS - Software Design', 'D&S SD', ''),
('3', 'ENN0000', 'TG', 'D&S ECOE - G&N COE', 'D&S G&N', ''),
('3', 'ENN0000', 'TG', 'D&S ET Test Strategy & Process', 'D&S TSP', ''),
('3', 'ENN0000', 'TG', 'D&S AERO AT ERT', 'D&S AERO', ''),

('4', 'ENN0000', 'TG', 'ASIC', 'ASIC', ''),

('5', 'ENN0000', 'TG', 'Guest', 'Guest', '');

--
-- Project Charters related tables
--

DROP TABLE IF EXISTS `ProjectCharter`;
CREATE TABLE `ProjectCharter` (
  `ProjectCharter_ID` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `SAP_ID` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
  `CostShare` float DEFAULT NULL,
  `LineManager` varchar(7) COLLATE utf8_unicode_ci NOT NULL,
  `Owner` varchar(7) COLLATE utf8_unicode_ci NOT NULL,
  `Status` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `CreationDateTime` datetime NOT NULL,
  `Customer_ID` int(11) NOT NULL,
  `Responsibility_ID` int(11) NOT NULL,
  `Year` year(4) NOT NULL,
  `FinalApprovalDate` date DEFAULT NULL,
  PRIMARY KEY (`ProjectCharter_ID`),
  KEY `ProjectCharter_fk` (`Owner`),
  KEY `ProjectCharter_fk1` (`LineManager`),
  KEY `ProjectCharter_fk2` (`Customer_ID`),
  KEY `ProjectCharter_fk3` (`Responsibility_ID`),
  CONSTRAINT `ProjectCharter_fk` FOREIGN KEY (`Owner`) REFERENCES `Person` (`EID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharter_fk1` FOREIGN KEY (`LineManager`) REFERENCES `Person` (`EID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharter_fk2` FOREIGN KEY (`Customer_ID`) REFERENCES `Customer` (`Customer_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharter_fk3` FOREIGN KEY (`Responsibility_ID`) REFERENCES `Responsibility` (`Responsibility_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


DROP TABLE IF EXISTS `ProjectCharterBudgetHistory`;
CREATE TABLE `ProjectCharterBudgetHistory` (
  `ProjectCharter_ID` int(11) NOT NULL,
  `Version` int(11) NOT NULL,
  `CreationDateTime` datetime NOT NULL,
  `Responsible` varchar(7) COLLATE utf8_unicode_ci NOT NULL,
  `Comment` varchar(500) COLLATE utf8_unicode_ci DEFAULT NULL,
  `LatestVersion` tinyint(4) NOT NULL,
  PRIMARY KEY (`Version`,`ProjectCharter_ID`),
  KEY `ProjectCharterBudgetHistory_fk` (`ProjectCharter_ID`),
  KEY `ProjectCharterBudgetHistory_fk1` (`Responsible`),
  CONSTRAINT `ProjectCharterBudgetHistory_fk` FOREIGN KEY (`ProjectCharter_ID`) REFERENCES `ProjectCharter` (`ProjectCharter_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharterBudgetHistory_fk1` FOREIGN KEY (`Responsible`) REFERENCES `Person` (`EID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;



DROP TABLE IF EXISTS `ProjectCharterBudget`;
CREATE TABLE `ProjectCharterBudget` (
  `ProjectCharterBudget_ID` int(11) NOT NULL AUTO_INCREMENT,
  `ProjectCharter_ID` int(11) NOT NULL,
  `Version` int(11) NOT NULL,
  `ResourceType` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `TechnicalGroup` int(11) DEFAULT NULL,
  `Subcontractor` int(11) DEFAULT NULL,
  `BudgetQ1` float DEFAULT NULL,
  `BudgetQ2` float DEFAULT NULL,
  `BudgetQ3` float DEFAULT NULL,
  `BudgetQ4` float DEFAULT NULL,
  PRIMARY KEY (`ProjectCharterBudget_ID`),
  KEY `ProjectCharterBudget_fk` (`TechnicalGroup`),
  KEY `ProjectCharterBudget_fk1` (`Version`),
  KEY `ProjectCharterBudget_fk2` (`ProjectCharter_ID`),
  KEY `ProjectCharterBudget_fk3` (`Subcontractor`),
  CONSTRAINT `ProjectCharterBudget_fk` FOREIGN KEY (`TechnicalGroup`) REFERENCES `OrganizationUnit` (`OrganizationUnit_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharterBudget_fk1` FOREIGN KEY (`Version`) REFERENCES `ProjectCharterBudgetHistory` (`Version`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharterBudget_fk2` FOREIGN KEY (`ProjectCharter_ID`) REFERENCES `ProjectCharter` (`ProjectCharter_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharterBudget_fk3` FOREIGN KEY (`Subcontractor`) REFERENCES `Subcontractor` (`Subcontractor_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


DROP TABLE IF EXISTS `ProjectCharterFileHistory`;
CREATE TABLE `ProjectCharterFileHistory` (
  `ProjectCharter_ID` int(11) NOT NULL,
  `Version` int(11) NOT NULL,
  `CreationDateTime` datetime NOT NULL,
  `FileName` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `Responsible` varchar(7) COLLATE utf8_unicode_ci NOT NULL,
  `Comment` varchar(500) COLLATE utf8_unicode_ci DEFAULT NULL,
  `LatestVersion` tinyint(4) NOT NULL,
  PRIMARY KEY (`Version`,`ProjectCharter_ID`),
  KEY `ProjectCharterFileHistory_fk` (`Responsible`),
  KEY `ProjectCharterFileHistory_fk1` (`ProjectCharter_ID`),
  CONSTRAINT `ProjectCharterFileHistory_fk` FOREIGN KEY (`Responsible`) REFERENCES `Person` (`EID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `ProjectCharterFileHistory_fk1` FOREIGN KEY (`ProjectCharter_ID`) REFERENCES `ProjectCharter` (`ProjectCharter_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


DROP TABLE IF EXISTS `ProjectCharterApprover`;
CREATE TABLE `ProjectCharterApprover` (
  `ProjectCharter_ID` int(11) NOT NULL,
  `Approver_EID` varchar(7) COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
  `Approval` tinyint(1) DEFAULT '0',
  `DecisionDateTime` datetime DEFAULT NULL,
  `Comment` varchar(500) COLLATE utf8_unicode_ci DEFAULT NULL,
  `AutoApproved` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`ProjectCharter_ID`,`Approver_EID`),
  KEY `ProjectCharterApprover_fk` (`ProjectCharter_ID`),
  CONSTRAINT `ProjectCharterApprover_fk` FOREIGN KEY (`ProjectCharter_ID`) REFERENCES `ProjectCharter` (`ProjectCharter_ID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


--
-- Update of table Person
--

-- add new column "OrganizationUnit_ID"
ALTER TABLE `Person` ADD COLUMN `OrganizationUnit_ID` INT AFTER `Email`;

--
-- `Person` table data update.
--

UPDATE     Person
SET        Person.OrganizationUnit_ID = 22 
WHERE      Person.Group_ID = 3
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 23 
WHERE      Person.Group_ID = 18
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 24
WHERE      Person.Group_ID = 2
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 26
WHERE      Person.Group_ID = 12
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 27
WHERE      Person.Group_ID = 13
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 29
WHERE      Person.Group_ID = 15
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 33
WHERE      Person.Group_ID = 14
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 34
WHERE      Person.Group_ID = 19
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 35
WHERE      Person.Group_ID = 44
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 36
WHERE      Person.Group_ID = 1
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 38
WHERE      Person.Group_ID = 7
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 39
WHERE      Person.Group_ID = 6
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 40
WHERE      Person.Group_ID = 41
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 41
WHERE      Person.Group_ID = 5
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 42
WHERE      Person.Group_ID = 4
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 43
WHERE      Person.Group_ID = 40
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 44
WHERE      Person.Group_ID = 45
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 45
WHERE      Person.Group_ID = 36
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 21
WHERE      Person.Group_ID = 16
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 8
WHERE      Person.Group_ID = 17
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 66
WHERE      Person.Group_ID = 72
AND        Group_Leader != 1
AND        Department_Manager !=1;

UPDATE Person
SET Person.OrganizationUnit_ID = (
SELECT OrganizationUnit.OrganizationUnit_ID FROM CostCenter
   LEFT JOIN OrganizationUnit ON OrganizationUnit.Name = CostCenter.Name 
            WHERE CostCenter.Name LIKE '%D&S%' AND Person.CostCenter = CostCenter.CostCenter_ID
)
WHERE Person.Group_ID = 60;

UPDATE Person
SET Person.OrganizationUnit_ID = (
SELECT OrganizationUnit.OrganizationUnit_ID FROM CostCenter
   LEFT JOIN OrganizationUnit ON OrganizationUnit.Name = CostCenter.Name 
            WHERE CostCenter.Name LIKE '%HAO%' AND Person.CostCenter = CostCenter.CostCenter_ID
)
WHERE Person.Group_ID = 70;

UPDATE Person
SET Person.OrganizationUnit_ID = (
SELECT OrganizationUnit.OrganizationUnit_ID FROM CostCenter
   LEFT JOIN OrganizationUnit ON OrganizationUnit.Name = CostCenter.Name 
            WHERE CostCenter.Name LIKE '%HAO%' AND Person.CostCenter = CostCenter.CostCenter_ID
)
WHERE Person.Group_ID = 73;

UPDATE     Person
SET        Person.OrganizationUnit_ID = 7
WHERE      Person.EID = 'E150630';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 10
WHERE      Person.EID = 'E456523';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 9
WHERE      Person.EID = 'E164534';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 41
WHERE      Person.EID = 'E312284';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 26
WHERE      Person.EID = 'E315195';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 19
WHERE      Person.EID = 'E329005';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 18
WHERE      Person.EID = 'E337992';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 42
WHERE      Person.EID = 'E338000';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 8
WHERE      Person.EID = 'E408191';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 6
WHERE      Person.EID = 'E410694';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 13
WHERE      Person.EID = 'E415887';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 27
WHERE      Person.EID = 'E445088';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 40
WHERE      Person.EID = 'E450710';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 21
WHERE      Person.EID = 'E483649';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 29
WHERE      Person.EID = 'E516358';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 16
WHERE      Person.EID = 'E544562';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 14
WHERE      Person.EID = 'E816085';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 15
WHERE      Person.EID = 'E807315';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 11
WHERE      Person.EID = 'e445090';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 33
WHERE      Person.EID = 'E806359';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 38
WHERE      Person.EID = 'E395356';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 18
WHERE      Person.EID = 'E275006';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 15
WHERE      Person.EID = 'E408978';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 16
WHERE      Person.EID = 'E371523';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 16
WHERE      Person.EID = 'E296690';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 16
WHERE      Person.EID = 'E401741';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 37
WHERE      Person.EID = 'E397710';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 37
WHERE      Person.EID = 'E804771';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 37
WHERE      Person.EID = 'E490891';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 37
WHERE      Person.EID = 'E556419';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 37
WHERE      Person.EID = 'E815009';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 25
WHERE      Person.EID = 'E383998';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 28
WHERE      Person.EID = 'E551833';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 31
WHERE      Person.EID = 'E324603';

UPDATE     Person
SET        Person.OrganizationUnit_ID = 45
WHERE      Person.EID = 'E459152';

ALTER TABLE `Person` ADD CONSTRAINT `Person_fk` FOREIGN KEY (`OrganizationUnit_ID`) REFERENCES `OrganizationUnit` (`OrganizationUnit_ID`) ON UPDATE CASCADE;
CREATE INDEX `Person_fk_idx` ON `Person` (`OrganizationUnit_ID`);

--
-- Procedures for setup/update of Paths in the OrganizationUnit table
--
DELIMITER ;;

DROP PROCEDURE IF EXISTS `GenerateOrgUnitPaths`;;
-- prefix_block_length parameter defines lenght of the block within path
-- specifying position of the element within the tree
--
-- Required MySQL setings:
-- max_sp_recursion_depth=15 (at least 15)
-- thread_stack= 393216 (example; default value might be sufficient)
-- 
-- Example of path:  001002001 (element is on 3rd level of a tree) - block is 3
-- Example of a call: CALL `GenerateOrgUnitPaths`(3) 
CREATE PROCEDURE `GenerateOrgUnitPaths`(IN prefix_block_length INT) 
BEGIN
  DECLARE org_unit_id INT;
  DECLARE done INT DEFAULT 0;
  DECLARE idx INT DEFAULT 0;
  DECLARE org_unit_path VARCHAR(30);
  DECLARE org_unit_cursor1 CURSOR FOR SELECT `OrganizationUnit_ID` FROM `OrganizationUnit` WHERE `OrganizationUnit_ID`=`Parent_ID`; 
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  
  -- reset of paths
  UPDATE `OrganizationUnit` SET `Path` = NULL; 
  
  OPEN org_unit_cursor1;
  REPEAT
    FETCH org_unit_cursor1 INTO org_unit_id;
    IF NOT done THEN
      SET idx = idx + 1;
      SET org_unit_path = LPAD(idx, prefix_block_length, '0');
      UPDATE `OrganizationUnit` SET `Path`=org_unit_path  WHERE `OrganizationUnit_ID`=org_unit_id;
      CALL `GenerateOrgUnitSubtreePaths`(org_unit_id, org_unit_path, prefix_block_length);
    END IF;
  UNTIL done END REPEAT;

  CLOSE org_unit_cursor1;  
END;;

DROP PROCEDURE IF EXISTS `GenerateOrgUnitSubtreePaths`;;
CREATE PROCEDURE `GenerateOrgUnitSubtreePaths`(IN parent INT, IN parent_path VARCHAR(30), IN prefix_block_length INT) 
BEGIN
  DECLARE org_unit_id INT;
  DECLARE done INT DEFAULT 0;
  DECLARE idx INT DEFAULT 0;
  DECLARE org_unit_path VARCHAR(30);
  DECLARE org_unit_cursor2 CURSOR FOR SELECT `OrganizationUnit_ID` FROM `OrganizationUnit` WHERE `Parent_ID`=parent AND `OrganizationUnit_ID` != parent_id; 
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  
  OPEN org_unit_cursor2;
  REPEAT
    FETCH org_unit_cursor2 INTO org_unit_id;
    IF NOT done THEN
      SET idx = idx + 1;
      SET org_unit_path = CONCAT(parent_path, LPAD(idx, prefix_block_length, '0'));
      UPDATE `OrganizationUnit` SET `Path`=org_unit_path WHERE `OrganizationUnit_ID`=org_unit_id;
      CALL `GenerateOrgUnitSubtreePaths`(org_unit_id, org_unit_path, prefix_block_length);
    END IF;
  UNTIL done END REPEAT;
  CLOSE org_unit_cursor2;  
END;;

DELIMITER ;

CALL `GenerateOrgUnitPaths`(3);

-- Examples of usage of Path column:
-- select all subitems of item with Path "001002" ordered for easier tree creation  
-- SELECT * FROM `OrganizationUnit` WHERE `Path` LIKE '001002%' AND `Path`!='001002' ORDER BY `Path`;

-- find path of an item with Path "001002002003" in the tree 
-- SELECT * FROM `OrganizationUnit` WHERE '001002002003' LIKE CONCAT(`Path`, '%') ORDER BY `Path`;
 
-- Table DataFile is not used anymore
DROP TABLE IF EXISTS `DataFile`;

-- Drop never used tables
DROP TABLE IF EXISTS `TaskNew`;
DROP TABLE IF EXISTS `WorkPackageNew`;
DROP TABLE IF EXISTS `ProjectNew`;

 
DELIMITER ;;

-- This triggers ensures that changes in exchange rates will be propagated 
-- to task plans for given year and month.
-- It is written defensively so if there are changes to other than
-- Value column data, nothing is done.
-- Reason for this trigger is to update budgets for tasks
-- which are coming from SAP in CZK and recalculated to USD based on exch. rate 
CREATE TRIGGER `ExchangeRateBudgetsUpdate` BEFORE UPDATE ON `ExchangeRate` FOR EACH ROW
  BEGIN
      -- Trigger can handle ONLY changes in the exchange rate Value column data, 
      -- If there would be changes to other columns result would be undefined
      -- It is limited only to CZK->USD ExchangeRate
      IF ((NEW.`Value` != OLD.`Value`) 
        AND (NEW.`Month` = OLD.`Month`) AND (NEW.`Year` = OLD.`Year`)
        AND (NEW.`SourceCurrency` = OLD.`SourceCurrency`) 
        AND (NEW.`TargetCurrency` = OLD.`TargetCurrency`)
        AND (NEW.`SourceCurrency` = 'CZK') AND (NEW.`TargetCurrency` = 'USD')) 
      THEN
          -- Recalculate all budgets in TaskPlan table for given Year and Month
          CASE NEW.`Month`
            WHEN 1 THEN
              UPDATE `TaskPlan` SET `January`=ROUND(`January` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 2 THEN
              UPDATE `TaskPlan` SET `February`=ROUND(`February` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 3 THEN
              UPDATE `TaskPlan` SET `March`=ROUND(`March` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 4 THEN
              UPDATE `TaskPlan` SET `April`=ROUND(`April` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 5 THEN
              UPDATE `TaskPlan` SET `May`=ROUND(`May` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 6 THEN
              UPDATE `TaskPlan` SET `June`=ROUND(`June` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 7 THEN
              UPDATE `TaskPlan` SET `July`=ROUND(`July` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 8 THEN
              UPDATE `TaskPlan` SET `August`=ROUND(`August` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 9 THEN
              UPDATE `TaskPlan` SET `September`=ROUND(`September` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 10 THEN
              UPDATE `TaskPlan` SET `October`=ROUND(`October` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 11 THEN
              UPDATE `TaskPlan` SET `November`=ROUND(`November` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
            WHEN 12 THEN
              UPDATE `TaskPlan` SET `December`=ROUND(`December` * OLD.`Value` / NEW.`Value`) WHERE `Year`=NEW.`Year`;
          END CASE;
      END IF;
  END;;

DELIMITER ;

-- 
-- Add CostCenter_ID to data
--
-- ATE (requires path column populated!)
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEEPZZA1' WHERE `Path` LIKE '001%';  
-- HAO 
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEMTZZ00' WHERE `Short` LIKE 'HAO MPE';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEMDZZST' WHERE `Short` LIKE 'HAO MSSD';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEMDZZ00' WHERE `Short` LIKE 'HAO MD';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEVEZZ00' WHERE `Short` LIKE 'HAO MIS';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEMAZZIS' WHERE `Short` LIKE 'HAO RCCSM';
-- D&S
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EAPCZZC1' WHERE `Short` LIKE 'D&S PP&C';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EECOZZC1' WHERE `Short` LIKE 'D&S CE';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEEDZZA6' WHERE `Short` LIKE 'D&S ASIC';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEEDZZC1' WHERE `Short` LIKE 'D&S ED';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEEDZZC2' WHERE `Short` LIKE 'D&S EM';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEEDZZC3' WHERE `Short` LIKE 'D&S PSE';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEGRZZC1' WHERE `Short` LIKE 'D&S BL';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEMDZZC1' WHERE `Short` LIKE 'D&S MD';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEQUZZC1' WHERE `Short` LIKE 'D&S PA&C';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEQUZZC2' WHERE `Short` LIKE 'D&S PIPA';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EESDZZC4' WHERE `Short` LIKE 'D&S SD';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EESDZZC5' WHERE `Short` LIKE 'D&S G&N';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EESDZZC6' WHERE `Short` LIKE 'D&S TSP';
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EESDZZC7' WHERE `Short` LIKE 'D&S AERO';
-- ASIC
UPDATE `OrganizationUnit` SET `CostCenter_ID`='EEEDZZA3' WHERE `Short` LIKE 'ASIC';

   