-- ATE Tool database upgrade script 
-- From version     : 1.7.x
-- To version       : 1.8.0
-- Target DB engine : MySQL 5.5.x

-- Adds new column into the table Person
ALTER TABLE `Person` ADD COLUMN `Status` TINYINT NOT NULL DEFAULT 1;

-- Adds new column into the table Hour
ALTER TABLE `Hour` CHANGE `Percentage` `Yield` DECIMAL(3,2);
ALTER TABLE `Hour` ADD COLUMN `Contract` DECIMAL(3,2) NULL DEFAULT '1.00' AFTER `Yield`;

-- -----------------------------------------------------
-- Table `tool`.`POAttributesAndBudget`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `tool`.`POAttributesAndBudget` ;

CREATE  TABLE IF NOT EXISTS `tool`.`POAttributesAndBudget` (
  `POAttributesAndBudget_ID` INT(11) AUTO_INCREMENT NOT NULL,
  `Project_ID` INT(11) NOT NULL,
  `Year` YEAR NOT NULL,
  `POValue` DECIMAL(20,2),
  `PONumber` VARCHAR(100) CHARACTER SET 'utf8' COLLATE 'utf8_unicode_ci',
  `Budget` DECIMAL(20,2),
  PRIMARY KEY (`POAttributesAndBudget_ID`),
  CONSTRAINT `POAttributesAndBudget_Project_fk`
    FOREIGN KEY (`Project_ID` )
    REFERENCES `tool`.`Project` (`Project_ID` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION
) ENGINE = InnoDB;

-- --------------------------------------------------------
-- Move data from unwanted columns into `tool`.`temp_ProjectPOAttributesAndBudget`
-- --------------------------------------------------------
DROP TABLE IF EXISTS `tool`.`temp_ProjectPOAttributesAndBudget`;

CREATE  TABLE IF NOT EXISTS `tool`.`temp_ProjectPOAttributesAndBudget` (
  `Project_ID` INT(11),
  `ProjectName` VARCHAR(500),
  `POValue` VARCHAR(500),
  `PONumber` VARCHAR(500),
  `Budget` DECIMAL(20,2)
) ENGINE = InnoDB;

INSERT INTO `temp_ProjectPOAttributesAndBudget` (`Project_ID`, `ProjectName`, `POValue`, `PONumber`, `Budget`)
    SELECT `Project_ID`, `Name`, `PO`, `PO_number`, `TotalBudget`
    FROM `Project`;

-- --------------------------------------------------------
-- Drop unwanted columns from table `tool`.`Project`
-- --------------------------------------------------------
ALTER TABLE `Project` DROP COLUMN `PO`;
ALTER TABLE `Project` DROP COLUMN `PO_number`;
ALTER TABLE `Project` DROP COLUMN `TotalBudget`;