-- ATE Tool database upgrade script 
-- From version     : 1.8.x
-- To version       : 1.9.0
-- Target DB engine : MySQL 5.5.x

-- Add column 'Fake' and 'ECORemkar'  	 	  	 	 
ALTER TABLE `tool`.`Project` ADD COLUMN `Fake` TINYINT NOT NULL DEFAULT '0';
ALTER TABLE `tool`.`Project` ADD COLUMN `ECORemark` TEXT NULL;
ALTER TABLE `tool`.`Project` MODIFY `Remark` TEXT;
ALTER TABLE `tool`.`Project` MODIFY `Description` TEXT;

-- Drop temporary table with unwanted content
DROP TABLE IF EXISTS `tool`.`temp_ProjectPOAttributesAndBudget`; 

-- Create new table for setting of displayed content
DROP TABLE IF EXISTS `tool`.`SettingDisplayedContent`;
CREATE TABLE IF NOT EXISTS `tool`.`SettingDisplayedContent` (
    `EID` VARCHAR(7) CHARACTER SET 'utf8' COLLATE 'utf8_unicode_ci',
    `OrganizationUnit_ID` INT(11) NOT NULL,
    PRIMARY KEY (`EID`, `OrganizationUnit_ID`),
    FOREIGN KEY (`EID`) REFERENCES `tool`.`Person` (`EID`) ON DELETE NO ACTION ON UPDATE CASCADE,
    FOREIGN KEY (`OrganizationUnit_ID`) REFERENCES `tool`.`OrganizationUnit` (`OrganizationUnit_ID`) ON DELETE NO ACTION ON UPDATE CASCADE
) ENGINE = InnoDB;

-- Create default setting of displayed content for each user of application
-- ATE users
INSERT INTO `tool`.`SettingDisplayedContent` (`EID`, `OrganizationUnit_ID`)
    SELECT `Person`.`EID`, 1 AS `OrganizationUnit_ID`
    FROM `Person`, `OrganizationUnit`
    WHERE `Person`.`OrganizationUnit_ID` = `OrganizationUnit`.`OrganizationUnit_ID` AND
          `OrganizationUnit`.`Path` LIKE '001%';
-- HAO users
INSERT INTO `tool`.`SettingDisplayedContent` (`EID`, `OrganizationUnit_ID`)
    SELECT `Person`.`EID`, 2 AS `OrganizationUnit_ID`
    FROM `Person`, `OrganizationUnit`
    WHERE `Person`.`OrganizationUnit_ID` = `OrganizationUnit`.`OrganizationUnit_ID` AND
          `OrganizationUnit`.`Path` LIKE '002%';
-- D&S users
INSERT INTO `tool`.`SettingDisplayedContent` (`EID`, `OrganizationUnit_ID`)
    SELECT `Person`.`EID`, 3 AS `OrganizationUnit_ID`
    FROM `Person`, `OrganizationUnit`
    WHERE `Person`.`OrganizationUnit_ID` = `OrganizationUnit`.`OrganizationUnit_ID` AND
          `OrganizationUnit`.`Path` LIKE '003%';
-- ASIC users
INSERT INTO `tool`.`SettingDisplayedContent` (`EID`, `OrganizationUnit_ID`)
    SELECT `Person`.`EID`, 4 AS `OrganizationUnit_ID`
    FROM `Person`, `OrganizationUnit`
    WHERE `Person`.`OrganizationUnit_ID` = `OrganizationUnit`.`OrganizationUnit_ID` AND
          `OrganizationUnit`.`Path` LIKE '004%';
-- Guests
INSERT INTO `tool`.`SettingDisplayedContent` (`EID`, `OrganizationUnit_ID`)
    SELECT `Person`.`EID`, 5 AS `OrganizationUnit_ID`
    FROM `Person`, `OrganizationUnit`
    WHERE `Person`.`OrganizationUnit_ID` = `OrganizationUnit`.`OrganizationUnit_ID` AND
          `OrganizationUnit`.`Path` LIKE '005%';

-- -----------------------------------------------------
-- Table `tool`.`AssignmentsCost`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `tool`.`AssignmentsCost` ;

CREATE TABLE IF NOT EXISTS `tool`.`AssignmentsCost` (
  `AssignmentsCost_ID` INT NOT NULL AUTO_INCREMENT,
  `Task_ID` INT NOT NULL,
  `Year` YEAR NOT NULL,
  `Month` INT NOT NULL,
  `Cost` INT NULL,
  PRIMARY KEY (`AssignmentsCost_ID`),
  INDEX `Task_ID_Year` (`Year` ASC, `Task_ID` ASC),
  CONSTRAINT `AssignmentsCost_Task`
    FOREIGN KEY (`Task_ID`)
    REFERENCES `tool`.`Task` (`Task_ID`)
    ON DELETE CASCADE
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

-- Adds new column into the table Person
-- To set correct value see TRAC ticket #313
ALTER TABLE `Person` ADD COLUMN `AccessLevel` ENUM('CZ', 'EU', 'Other') NOT NULL DEFAULT 'Other';

-- Adds new column into the table Project
ALTER TABLE `Project` ADD COLUMN `SecurityLevel` ENUM('CZ', 'EU', 'NLR') NOT NULL DEFAULT 'NLR';

-- Adds new column into the table Setting
ALTER TABLE `Setting` ADD COLUMN `ShowFakeProjects` TINYINT(1) NOT NULL DEFAULT '1';

-- Store new settings into the table GlobalSetting
-- IDs of organization units of type SBE
-- ATE
INSERT INTO `GlobalSetting` (`Key`, `Value`, `Default`, `DataType`)
VALUES ('orgUnit.id.ATE', 1, '', 'int');
-- HAO
INSERT INTO `GlobalSetting` (`Key`, `Value`, `Default`, `DataType`)
VALUES ('orgUnit.id.HAO', 2, '', 'int');
-- D&S
INSERT INTO `GlobalSetting` (`Key`, `Value`, `Default`, `DataType`)
VALUES ('orgUnit.id.D&S', 3, '', 'int');
-- ASIC
INSERT INTO `GlobalSetting` (`Key`, `Value`, `Default`, `DataType`)
VALUES ('orgUnit.id.ASIC', 4, '', 'int');
-- Guest
INSERT INTO `GlobalSetting` (`Key`, `Value`, `Default`, `DataType`)
VALUES ('orgUnit.id.Guest', 5, '', 'int');
-- HTS
INSERT INTO `GlobalSetting` (`Key`, `Value`, `Default`, `DataType`)
VALUES ('orgUnit.id.HTS', 87, '', 'int');