# FileName: personAutoGeneration.ps1
#=============================================================================
# Script Name: [HON PLANNING TOOL Person Report Auto Generation]
# Created: [10.9.2016]
# Version: [1.0]
# Author: [Leos Navratil]
# Email: [leos.navratil@honeywell.com]
# Company: [Honeywell]  
# Arguments: None
# =============================================================================
# Purpose: This script is to be setup in Windows Server / Windows 7 
# Task Scheduler to run regarly every day in the early morning to generate Person Report.
# =============================================================================

$my_import_log="C:\inetpub\wwwroot\hon-planning-tool\log\auto-person-generation.log"
# token HTTP parameter is setup in the ATE Planning Tool database 
# in table GlobalSettings in a Value column where Key="PersonReport.credentials.cronToken" 
$my_import_url="http://ate-apps.honeywell.com/hon-planning-tool/?presenter=PersonReportAutoGeneration&token=b5e143f0cb8663202b3c65a4d4cdb034&action=generateReport"
# run only once and max for 20 mins
$my_wget_cmd="c:\Program Files (x86)\UnixUtils\bin\wget.exe"
$my_wget_params=@("-t","1","-T","1200","-O","-","$my_import_url") 
$my_unix_date_format="%Y/%m/%d %H:%M:%S"

#logrotate first if log is greater than 500kB
if (Test-Path $my_import_log) { 
    if ((Get-Item $my_import_log).length -gt 500kb) {
        $old_log= $my_import_log -replace ".log$", ("-" + (Get-Date -UFormat "%Y%m%d-%H%M%S") + ".log")
        Move-Item $my_import_log $old_log
    }
}

$my_start_date=(Get-Date -UFormat $my_unix_date_format)
Add-Content -Path $my_import_log -Value "--- START OF AUTO PERSON REPORT GENERATION: $my_start_date"
& $my_wget_cmd $my_wget_params | Add-Content -Path $my_import_log     
$my_end_date=(Get-Date -UFormat $my_unix_date_format)
Add-Content -Path $my_import_log -Value "--- END OF AUTO PERSON REPORT GENERATION: $my_end_date"

exit