<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2012 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package presenters
 */

/**
 * Presenter started by cron process to run ECharge import.
 * Authentication is done by url (known token).
 *
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
class EChargeImportCronAccessPresenter extends TokenAccessPresenter
{
	/* authentication token setup */
	const AUTH_TOKEN_NAME = 'token',
		AUTH_TOKEN_KEY = 'eCharge.credentials.cronToken';

    /**
     * Service for ECharge importing.
     * @var EChargeImportService
     */
	private $eChargeImportService;
	
    /**
     * Returns http parameter name with authentication token.
     * 
     * @return string
     */
	protected function getAuthTokenName()
	{
		return self::AUTH_TOKEN_NAME;
	}

    /**
     * Returns http parameter name with authentication token.
	 * 
     * @return string
     */
	protected function getAuthTokenSettingsKey()
	{
		return self::AUTH_TOKEN_KEY;
	}
	
    /**
     * Nette default render method 
     */
	public function renderDefault()
	{
        $this->template->lastUpdated = $this->context->actualsRepository->getLastImportDate(Actuals::SOURCE_ECHARGE);
	}
    
	/**
     * Run method 
     */
    public function renderRun()
    {
//		/* init logging */
//		$logs_suffix = time().'-'. rand(1, 9);
//		$current_log_file_name = 'echarge_import-'.$logs_suffix.'.html';
//		$batch_id = 'echarge-'.$logs_suffix;
//		$filelog_path = TEMP_DIR . DIRECTORY_SEPARATOR . $current_log_file_name;
//        $filelog = $this->context->createFileLogger($filelog_path, $batch_id, "ECHARGE ACTUALS") ;
//		$multilog = new MultiLogger();
//		$multilog->add($filelog);
//		$multilog->add($this->context->createLogger($batch_id, "ECHARGE ACTUALS"));
//		
//        $import_result = FALSE;
//		$import_ex_error = '';
//        $this->eChargeImportService = new EChargeImportService($this->context, $multilog);
//		// workaround to keep connectoin alive because this operation takes up to 12 minutes
//		$this->eChargeImportService->setReportProgress(true);
//        
//        try
//        {
//            $import_result = $this->eChargeImportService->runImport();
//            if (!$import_result)
//                $import_ex_error = 'ECharge actuals import was not completed successfully!';
//        }
//        catch (EChargeImportServiceException $e)
//        {
//            Debugger::log('eCharge import failed: ' . $e->getMessage(), Debugger::ERROR);
//            $import_result = FALSE;
//            $import_ex_error = $e->getMessage();
//			$multilog->log('eCharge import failed: ' . $e->getMessage(), ILogger::ERROR);
//		}
//
//        $this->eChargeImportService = new EChargeIASAPImportService($this->context, $multilog);
//        
//        try
//        {
//            $this->eChargeImportService->runImport();
//        }
//        catch (EChargeIASAPImportServiceException $e)
//        {
//            Debugger::log('eCharge import failed: ' . $e->getMessage(), Debugger::ERROR);
//			$multilog->log('eCharge import failed: ' . $e->getMessage(), ILogger::ERROR);
//        }
//		
//		if (!$import_result)
//		{   
//			if (!$this->context->globalSetting->exists('mail.adminList'))
//				throw new InvalidStateException("Undefined list of email addresses for notifiying of ECharge import failure!");
//			$mail = $this->context->nette->createMail();
//			$mail->setFrom($this->context->parameters['mailer']['from']);
//			$emails = explode(',', $this->context->globalSetting->get('mail.adminList'));
//			$valid_notify_emails = 0;
//			foreach ($emails as $email) 
//			{
//				$notify_email = trim($email);
//				if (Validators::isEmail($notify_email))
//				{
//					$mail->addTo($notify_email);
//					$valid_notify_emails++;
//				}
//				else
//					Debugger::log('Invalid email address specified: '.$notify_email, Debugger::WARNING);
//			}
//			if ($valid_notify_emails)
//			{
//				$mail->setSubject('HON Planning Tool - ECharge actuals import failed @ ' . date('m-d-Y H:i:s'))
//					->setBody($import_ex_error)
//					->addAttachment($filelog_path);
//				$mail->send();
//			}
//			else
//				Debugger::log('Cannot notify about ECharge import failure! No valid email addresses specified.', Debugger::WARNING);
//		}			
//		$filelog = NULL; // clean up (save file)
//		$this->template->result			= $import_result;
//		$this->template->error			= $import_ex_error;
//        $this->template->lastUpdated    = $this->context->actualsRepository->getLastImportDate(Actuals::SOURCE_ECHARGE);
//        $this->template->logfilePath    = basename(TEMP_DIR) . '/' . $current_log_file_name;
//        
		$allActivePersons = $this->context->personRepository->findAllByOrgUnitPath('001');
		$i = 0;
		foreach ($allActivePersons as $eid => $person)
		{
			if($person->Status == true)
			{
				$wh2016 = $this->context->workableHourRepository->find(2016, $person->ID);
				if($wh2016)
				{
					$wh2017 = $this->context->workableHourRepository->find(2017, $person->ID);
					if($wh2017)
					{
						$wh2017->isAOP = true;
						$wh2017->Contract = $wh2016->Contract*100;
						$wh2017->Yield = $wh2016->Yield*100;
						$wh2017->setMonthHours(null, 1);
						$wh2017->setMonthHours(null, 2);
						$wh2017->setMonthHours(null, 3);
						$wh2017->setMonthHours(null, 4);
						$wh2017->setMonthHours(null, 5);
						$wh2017->setMonthHours(null, 6);
						$wh2017->setMonthHours(null, 7);
						$wh2017->setMonthHours(null, 8);
						$wh2017->setMonthHours(null, 9);
						$wh2017->setMonthHours(null, 10);
						$wh2017->setMonthHours(null, 11);
						$wh2017->setMonthHours(null, 12);
						//Update
						if($this->context->workableHourRepository->update($wh2017))
						{
							
						}
						else
						{
							echo 'mame problem update';
							dump($person); die;
						}
					}
					else
					{
						$wh2017 = new WorkableHour();
						$wh2017->ID = $person->ID;
						$wh2017->Year = 2017;
						$wh2017->isAOP = true;
						$wh2017->Contract = $wh2016->Contract*100;
						$wh2017->Yield = $wh2016->Yield*100;
						$wh2017->setMonthHours(null, 1);
						$wh2017->setMonthHours(null, 2);
						$wh2017->setMonthHours(null, 3);
						$wh2017->setMonthHours(null, 4);
						$wh2017->setMonthHours(null, 5);
						$wh2017->setMonthHours(null, 6);
						$wh2017->setMonthHours(null, 7);
						$wh2017->setMonthHours(null, 8);
						$wh2017->setMonthHours(null, 9);
						$wh2017->setMonthHours(null, 10);
						$wh2017->setMonthHours(null, 11);
						$wh2017->setMonthHours(null, 12);
						$wh2017->setRemark('');
						//Create
						if($this->context->workableHourRepository->create($wh2017))
						{
							
						}
						else
						{
							echo 'mame problem create';
							dump($person); die;
						}
					}
				}
			$i++;
			}
		}
		echo $i;
		echo 'Good Job :D';
		die;
    }
}