<?php

class ReportPresenter extends SecuredPresenter
{

    private $Project;
    private $Year;
    
    public $table;

    public function __construct(DIContainer $context)
    {
        parent::__construct($context);

        $this->Project = new ProjectHeader(6);
//        $month = 'January';
//        echo "<pre>"; print_r($this->Project->getPlannedLaborHours(2011, $month)); echo "\n";
//        echo "<pre>"; print_r($this->Project->getAssignedHours(2011, $month)); echo "\n";
//        echo "<pre>"; print_r($this->Project->getActualHours(2011, $month)); echo "\n";
//        echo "<pre>"; print_r($this->Project->getPlannedLaborHours(2011, $month)); echo "\n";
//        echo "<pre>"; print_r($this->Project->getResources(2011, $month)); echo "\n";
//        echo "<pre>"; print_r($this->Project);
		// current year is default
        $this->Year = 0 + date('Y', time());

		$this->table = Html::el('table')->class('report');

        $row = $this->table->create('tr');

        $row->create('th');
        $row->create('th');
        $row->create('th');
        $row->create('th')->setText('Q1');
        $row->create('th')->setText('Jan');
        $row->create('th')->setText('Feb');
        $row->create('th')->setText('Mar');
        $row->create('th')->setText('Q2');
        $row->create('th')->setText('Apr');
        $row->create('th')->setText('May');
        $row->create('th')->setText('Jun');
        $row->create('th')->setText('Q3');
        $row->create('th')->setText('Jul');
        $row->create('th')->setText('Aug');
        $row->create('th')->setText('Sep');
        $row->create('th')->setText('Q4');
        $row->create('th')->setText('Oct');
        $row->create('th')->setText('Nov');
        $row->create('th')->setText('Dec');
        $row->create('th')->setText('Cum. to date');
        $row->create('th')->setText('Total');

    }

    public function renderDefault()
    {
        if ($this->isAjax())
        {
			if (property_exists($this->payload, 'Project_ID'))
			{
				$this->Project = new ProjectHeader($this->payload->Project_ID);
				$this->fillTable();
			}
			else
				Debugger::log('Project ID not sent from form!', Debugger::ERROR);
        }
		else
	        $this->table = NULL;
        $this->template->table = $this->table;
        
    }

    public function createComponentProjectsForm($name)
    {
        $form = new AppForm($this, $name);
        $projects = $this->context->projectModel->getProjectsByFilter();
        $projectsValues = array();
        foreach ($projects as $project)
        {
            $projectsValues[$project->Project_ID] = $project->Name;
        }
        $form->addSelect('project', 'Project', $projectsValues);
        $form->getElementPrototype()->class('ajax');
        $form->onSuccess[] = array($this, 'ProjectsFormSubmitted');
        return $form;
    }

    public function ProjectsFormSubmitted($form)
    {
        $values = $form->getValues();

        if ($this->isAjax())
        {
             $this->payload->Project_ID = $values['project'];
             $this->invalidateControl('table');
        }
    }

    private function fillTable($parent = NULL)
    {

        $Q1 = array('January', 'February', 'March');
        $Q2 = array('April', 'May', 'June');
        $Q3 = array('July', 'August', 'September');
        $Q4 = array('October', 'November', 'December');

        $cum = array();
        $month = 0;
        while($month++ < date('n') - 1)
			$cum[] = FiscalCalendar::fiscalMonthIndexToName($month - 1, true);
        if($parent == NULL)
            $parent = $this->Project;

//        if($parent instanceof WorkPackageDeprecated && $parent->Name != 'Actuals Waste')
            if(!$parent->getPlannedLaborHours($this->Year) && !$parent->getActualHours($this->Year))
                return;
		switch (get_class($parent))
		{
			case 'ProjectHeader':
				$css_class = 'Project';
				break;
			case 'WorkPackageDeprecated':
				$css_class = 'WorkPackage';
				break;
			case 'TaskDepreciated':
				$css_class = 'Task';
				break;
			default:
				$css_class = '';
				break;
		}
			
        $row = $this->table->create('tr')->class($css_class)->addClass('topBorder');
        $row->create('td')->setText($parent->Name)->rowSpan(4)->class('noRightBorder');
        if($parent instanceof WorkPackageDeprecated)
            $td->style['padding-left'] = '25px';
        elseif($parent instanceof TaskDepreciated)
            $td->style['padding-left'] = '45px';
        $row->create('td')->setText($parent->SAP_ID)->rowSpan(4);
        $row->create('td')->setText('Delta');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, $Q1) - $parent->getActualHours($this->Year, $Q1), 2))->class('dark')->addClass('number')->addClass('bgblue3');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'January') - $parent->getActualHours($this->Year, 'January'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'February') - $parent->getActualHours($this->Year, 'February'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'March') - $parent->getActualHours($this->Year, 'March'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, $Q2) - $parent->getActualHours($this->Year, $Q2), 2))->class('dark')->class('number')->addClass('bgblue3');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'April') - $parent->getActualHours($this->Year, 'April'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'May') - $parent->getActualHours($this->Year, 'May'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'June') - $parent->getActualHours($this->Year, 'June'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, $Q3) - $parent->getActualHours($this->Year, $Q3), 2))->class('dark')->addClass('number')->addClass('bgblue3');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'July') - $parent->getActualHours($this->Year, 'July'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'August') - $parent->getActualHours($this->Year, 'August'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'September') - $parent->getActualHours($this->Year, 'September'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, $Q4) - $parent->getActualHours($this->Year, $Q4), 2))->class('dark')->addClass('number')->addClass('bgblue3');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'October') - $parent->getActualHours($this->Year, 'October'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'November') - $parent->getActualHours($this->Year, 'November'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, 'December') - $parent->getActualHours($this->Year, 'December'), 2))->class('number');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year, $cum) - $parent->getActualHours($this->Year, $cum), 2))->class('number')->addClass('bgblue4');
        $row->create('td')->setText(round($parent->getAssignedHours($this->Year) - $parent->getActualHours($this->Year), 2))->class('noRightBorder')->addClass('number')->addClass('bgblue3');

        $row = $this->table->create('tr')->class($css_class)->addClass('txtblue2 topBorderLight');
        $row->create('td')->setText('Plan');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, $Q1))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'January'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'February'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'March'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, $Q2))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'April'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'May'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'June'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, $Q3))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'July'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'August'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'September'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, $Q4))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'October'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'November'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, 'December'))->class('number');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year, $cum))->class('number')->addClass('bgblue4')->addClass('txtblue1');
        $row->create('td')->setText($parent->getPlannedLaborHours($this->Year))->class('noRightBorder')->addClass('number')->addClass('bgblue3');

        $row = $this->table->create('tr')->class($css_class)->addClass('txtblue2 topBorderLight');
        $row->create('td')->setText('Assigned');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, $Q1))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'January'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'February'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'March'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, $Q2))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'April'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'May'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'June'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, $Q3))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'July'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'August'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'September'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, $Q4))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'October'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'November'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, 'December'))->class('number');
        $row->create('td')->setText($parent->getAssignedHours($this->Year, $cum))->class('number')->addClass('bgblue4')->addClass('txtblue1');
        $row->create('td')->setText($parent->getAssignedHours($this->Year))->class('noRightBorder')->addClass('number')->addClass('bgblue3');

        $row = $this->table->create('tr')->class($css_class)->addClass('txtblue2 topBorderLight');
        $row->create('td')->setText('Actuals');
        $row->create('td')->setText($parent->getActualHours($this->Year, $Q1))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'January'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'February'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'March'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, $Q2))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'April'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'May'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'June'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, $Q3))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'July'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'August'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'September'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, $Q4))->class('number')->addClass('bgblue3');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'October'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'November'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, 'December'))->class('number');
        $row->create('td')->setText($parent->getActualHours($this->Year, $cum))->class('number')->addClass('bgblue4')->addClass('txtblue1');
        $row->create('td')->setText($parent->getActualHours($this->Year))->class('noRightBorder')->addClass('number')->addClass('bgblue3');

        if($parent instanceof TaskDepreciated)
        {

             $resourcesMerged = $this->mergeArrays($parent->getActuals($this->Year), $parent->getResources($this->Year));

//            echo "<pre>"; print_r($parent->getActuals($this->Year));
//            echo "<pre>"; print_r($parent->getResources($this->Year));
//            echo "<pre>"; print_r($resourcesMerged);

            foreach($resourcesMerged as $resource)
            {
                $row = $this->table->create('tr')->class('Task_Plan')->addClass('topBorder');
                $td = $row->create('td')->rowSpan(3)->setText($resource['Surname'] . ', ' . $resource['Name'])->addClass('noRightBorder');
                $td->style['padding-left'] = '65px';
                $row->create('td')->setText($resource['EID'])->rowSpan(3);
                $row->create('td')->setText('Delta');
                $row->create('td')->setText(round(
                    @$resource['resources'][0] - @$resource['actuals'][0] +
                    @$resource['resources'][1] - @$resource['actuals'][1] +
                    @$resource['resources'][2] - @$resource['actuals'][2]
                ), 2)->class('number')->addClass('bgblue3');
                $row->create('td')->setText(round(@$resource['resources'][0] - @$resource['actuals'][0]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][1] - @$resource['actuals'][1]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][2] - @$resource['actuals'][2]), 2)->class('number');
                $row->create('td')->setText(round(
                    @$resource['resources'][3] - @$resource['actuals'][3] +
                    @$resource['resources'][4] - @$resource['actuals'][4] +
                    @$resource['resources'][5] - @$resource['actuals'][5]
                ), 2)->class('number')->addClass('bgblue3');
                $row->create('td')->setText(round(@$resource['resources'][3] - @$resource['actuals'][3]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][4] - @$resource['actuals'][4]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][5] - @$resource['actuals'][5]), 2)->class('number');
                $row->create('td')->setText(round(
                    @$resource['resources'][6] - @$resource['actuals'][6] +
                    @$resource['resources'][7] - @$resource['actuals'][7] +
                    @$resource['resources'][8] - @$resource['actuals'][8]
                ), 2)->class('number')->addClass('bgblue3');
                $row->create('td')->setText(round(@$resource['resources'][6] - @$resource['actuals'][6]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][7] - @$resource['actuals'][7]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][8] - @$resource['actuals'][8]), 2)->class('number');
                $row->create('td')->setText(round(
                    @$resource['resources'][9] - @$resource['actuals'][9] +
                    @$resource['resources'][10] - @$resource['actuals'][10] +
                    @$resource['resources'][11] - @$resource['actuals'][11]
                ), 2)->class('number')->addClass('bgblue3');
                $row->create('td')->setText(round(@$resource['resources'][9] - @$resource['actuals'][9]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][10] - @$resource['actuals'][10]), 2)->class('number');
                $row->create('td')->setText(round(@$resource['resources'][11] - @$resource['actuals'][11]), 2)->class('number');
                $cumHrs = 0;
                foreach($cum as $monthNumber => $month)
                    $cumHrs += round(@$resource['resources'][$monthNumber] - @$resource['actuals'][$monthNumber], 2);
                $row->create('td')->setText($cumHrs)->class('number')->addClass('bgblue4')->addClass('txtblue1');
                $row->create('td')->setText(round(
                    @$resource['resources'][0] - @$resource['actuals'][0] +
                    @$resource['resources'][1] - @$resource['actuals'][1] +
                    @$resource['resources'][2] - @$resource['actuals'][2] +
                    @$resource['resources'][3] - @$resource['actuals'][3] +
                    @$resource['resources'][4] - @$resource['actuals'][4] +
                    @$resource['resources'][5] - @$resource['actuals'][5] +
                    @$resource['resources'][6] - @$resource['actuals'][6] +
                    @$resource['resources'][7] - @$resource['actuals'][7] +
                    @$resource['resources'][8] - @$resource['actuals'][8] +
                    @$resource['resources'][9] - @$resource['actuals'][9] +
                    @$resource['resources'][10] - @$resource['actuals'][10] +
                    @$resource['resources'][11] - @$resource['actuals'][11]
                ), 2)->class('noRightBorder')->addClass('number');

                $row = $this->table->create('tr')->class('Task_Plan');
                $row->create('td')->setText('Assigned');
                $row->create('td')->setText(
                    @$resource['resources'][0]+
                    @$resource['resources'][1]+
                    @$resource['resources'][2]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@$resource['resources'][0])->class('number');
                $row->create('td')->setText(@$resource['resources'][1])->class('number');
                $row->create('td')->setText(@$resource['resources'][2])->class('number');
                $row->create('td')->setText(
                    @$resource['resources'][3]+
                    @$resource['resources'][4]+
                    @$resource['resources'][5]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@$resource['resources'][3])->class('number');
                $row->create('td')->setText(@$resource['resources'][4])->class('number');
                $row->create('td')->setText(@$resource['resources'][5])->class('number');
                $row->create('td')->setText(
                    @$resource['resources'][6]+
                    @$resource['resources'][7]+
                    @$resource['resources'][8]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@$resource['resources'][6])->class('number');
                $row->create('td')->setText(@$resource['resources'][7])->class('number');
                $row->create('td')->setText(@$resource['resources'][8])->class('number');
                $row->create('td')->setText(
                    @$resource['resources'][9]+
                    @$resource['resources'][10]+
                    @$resource['resources'][11]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@$resource['resources'][9])->class('number');
                $row->create('td')->setText(@$resource['resources'][10])->class('number');
                $row->create('td')->setText(@$resource['resources'][11])->class('number');
                $cumHrs = 0;
                foreach($cum as $monthNumber => $month)
                    $cumHrs += @$resource['resources'][$monthNumber];
                $row->create('td')->setText($cumHrs)->class('number')->addClass('bgblue4')->addClass('txtblue1');
                $row->create('td')->setText(
                    @$resource['resources'][0]+
                    @$resource['resources'][1]+
                    @$resource['resources'][2]+
                    @$resource['resources'][3]+
                    @$resource['resources'][4]+
                    @$resource['resources'][5]+
                    @$resource['resources'][6]+
                    @$resource['resources'][7]+
                    @$resource['resources'][8]+
                    @$resource['resources'][9]+
                    @$resource['resources'][10]+
                    @$resource['resources'][11]
                )->class('noRightBorder')->addClass('number');

                $row = $this->table->create('tr')->class('Task_Plan');
                $row->create('td')->setText('Actuals');
                $row->create('td')->setText(
                    @$resource['actuals'][0]+
                    @$resource['actuals'][1]+
                    @$resource['actuals'][2]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@@$resource['actuals'][0])->class('number');
                $row->create('td')->setText(@$resource['actuals'][1])->class('number');
                $row->create('td')->setText(@$resource['actuals'][2])->class('number');
                $row->create('td')->setText(
                    @$resource['actuals'][3]+
                    @$resource['actuals'][4]+
                    @$resource['actuals'][5]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@$resource['actuals'][3])->class('number');
                $row->create('td')->setText(@$resource['actuals'][4])->class('number');
                $row->create('td')->setText(@$resource['actuals'][5])->class('number');
                $row->create('td')->setText(
                    @$resource['actuals'][6]+
                    @$resource['actuals'][7]+
                    @$resource['actuals'][8]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@$resource['actuals'][6])->class('number');
                $row->create('td')->setText(@$resource['actuals'][7])->class('number');
                $row->create('td')->setText(@$resource['actuals'][8])->class('number');
                $row->create('td')->setText(
                    @$resource['actuals'][9]+
                    @$resource['actuals'][10]+
                    @$resource['actuals'][11]
                )->class('number')->addClass('bgblue3');
                $row->create('td')->setText(@$resource['actuals'][9])->class('number');
                $row->create('td')->setText(@$resource['actuals'][10])->class('number');
                $row->create('td')->setText(@$resource['actuals'][11])->class('number');
                $cumHrs = 0;
                foreach($cum as $monthNumber => $month)
                    $cumHrs += @$resource['actuals'][$monthNumber];
                $row->create('td')->setText($cumHrs)->class('number')->addClass('bgblue4')->addClass('txtblue1');
                $row->create('td')->setText(
                    @$resource['actuals'][0]+
                    @$resource['actuals'][1]+
                    @$resource['actuals'][2]+
                    @$resource['actuals'][3]+
                    @$resource['actuals'][4]+
                    @$resource['actuals'][5]+
                    @$resource['actuals'][6]+
                    @$resource['actuals'][7]+
                    @$resource['actuals'][8]+
                    @$resource['actuals'][9]+
                    @$resource['actuals'][10]+
                    @$resource['actuals'][11]
                )->class('noRightBorder')->addClass('number');
            }
        }

        foreach($parent->getChildren() as $child)
            $this->fillTable($child);

    }

    /**
     * Merge arrays recursively with overwrite.
     *
     * @param <array> $Arr1 Array to merge.
     * @param <array> $Arr2 Array to merge.
     * @return <array> Merged array.
     */
    private function mergeArrays($Arr1, $Arr2)
    {
        
        foreach($Arr2 as $key => $Value)
        {
            if(array_key_exists($key, $Arr1) && is_array($Value))
                $Arr1[$key] = $this->mergeArrays($Arr1[$key], $Arr2[$key]);
            else
                $Arr1[$key] = $Value;
        }

        return $Arr1;

    }

}
