<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2016 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Actuals sap temp repository access class.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class ActualsSAPTempRepository extends Object
{
    /** @var IActualsSAPTempMapper */
    private $mapper;

    public function __construct(IActualsSAPTempMapper $mapper)
    {
        $this->mapper = $mapper;
    }	
	
	/**
	 * Deletes records associated with given task SAP ID.
	 * 
	 * @param String $sapID Task SAP ID.
	 * @return boolean TRUE if operation ended with success, FALSE otherwise.
	 */
	public function deleteActualsByTaskSAPID($sapID)
	{
		return $this->mapper->deleteActualsByTaskSAPID($sapID);
	}
	
	/**
     * Moves actuals into ActualsSapTemp.
     * 
	 * @param String $sapID Task SAP ID.
     * @return boolean Returns true if move successfull, otherwiste returns false.
     */
    public function moveIntoActualsSapTemp($sapID)
    {
		return $this->mapper->moveIntoActualsSapTemp($sapID);
    }
	
	/**
     * Moves actuals into Actuals.
     * 
	 * @param String $sapID Task SAP ID.
     * @return boolean Returns true if move successfull, otherwiste returns false.
     */
    public function moveIntoActuals($sapID)
    {
		return $this->mapper->moveIntoActuals($sapID);
	}
}