<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2011 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Customer represents customer of the project.
 *
 * @author Jiri Zajic <jiri.zajic@honeywell.com>
 */
class Customer extends Object
{
	/** @var string */
	private $id;
	/** @var string */
	private $name;
	/** @var string */
	private $responsible;
	/** @var string */
	private $remarks;
	

	public function __construct()
	{
	}

    /**
     * Sets customer ID.
     * 
     * @param $id string
     */
	public function setID($id)
	{
		$this->id = $id;
	}

    /**
     * Gets customer ID.
     * 
     * @return string
     */
	public function getID()
	{
		return $this->id;
	}	
	
    /**
     * Sets customer name.
     * 
     * @param string $name
     */
	public function setName($name)
	{
		$this->name = $name;
	}

    /**
     * Gets customer name.
     * 
     * @return string
     */
	public function getName()
	{
		return $this->name;
	}
	
	/**
	 * Sets responsible.
	 * @param string $eid
	 */
	public function setResponsible($eid)
	{
		$this->responsible = Person::processEID($eid);
	}
	
	/**
	 * Gets responsible.
	 * @return string
	 */
	public function getResponsible()
	{
		return $this->responsible;
	}
	
	/**
	 * Sets remarks.
	 * @param string $text
	 */
	public function setRemarks($text)
	{
		$this->remarks = $text;
	}
	
	/**
	 * Gets remarks.
	 * @return string
	 */
	public function getRemarks()
	{
		return $this->remarks;
	}

}
