<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2011 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Ancestor class of all Dibi access mapping classes.
 *
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
class DibiMapper extends Object
{
    /** @var DibiConnection connection to database */
    protected $conn;

    public function __construct(DibiConnection $conn = NULL)
    {
		if ($conn == NULL)
			$this->conn = dibi::getConnection();
		else
			$this->conn = $conn;
    }
	
	/**
	 * Converts DateTime to date.
	 * @param Datetime $datetime
	 * @return string In case $datetime is not empty returns date in format YYYY-MM-DD. NULL otherwise.
	 */
	public function dateOnly($datetime)
	{
		if ($datetime instanceof DateTime)
		    return $datetime->format('Y-m-d');
		
		return NULL;
	}

}