<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2015 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing actualsTemp for iASAP.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
interface IActualsTempForIASAPMapper
{
	
    /**
     * Returns all actuals.
     * 
     * @return array Associative array of actuals.
     */
    public function findAll();
			
	/**
	 * Deletes all actuals.
	 * 
	 * @return boolean
	 */
	public function deleteAll();
	
	/**
     * Moves actuals record.
     * 
     * @return boolean Returns true if move successfull, otherwiste returns false.
     */
    public function moveAll();
	
    /**
     * Saves new Actuals record for iASAP.
     * 
     * @param ActualsTempForIASAP $actual
     * @return boolean Returns true if save successfull, otherwiste returns false.
     */
    public function save(ActualsTempForIASAP $actual);
}