<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2015 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing actualsTemp.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
interface IActualsTempMapper
{
	
    /**
     * Returns all actuals.
     * 
	 * @param int $source Should be in range of ActualsTemp::SOURCE_*
     * @return array Associative array of actuals.
     */
    public function findAll($source);
			
	/**
	 * Deletes all actuals.
	 * 
	 * @param int $source Should be in range of ActualsTemp::SOURCE_*
	 * @return boolean
	 */
	public function deleteAll($source);
	
	/**
     * Moves actuals record.
     * 
	 * @param int $source Should be in range of ActualsTemp::SOURCE_*
     * @return boolean Returns true if move successfull, otherwiste returns false.
     */
    public function moveAll($source);
	
    /**
     * Saves new Actuals record.
     * 
     * @param Actuals $actual
     * @return boolean Returns true if save successfull, otherwiste returns false.
     */
    public function save(ActualsTemp $actual);
	
	/**
     * Adds new Actuals record.
     * If Actuals record does not exist, new one is inserted.
     * If Actuals record exists, it is updated (hours are added).
     * 
     * @param Actuals $actual
     * @return boolean Returns true if adding successfull, otherwise returns false.
     */
    public function add(ActualsTemp $actual);
}