<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2014 Honeywell International spol. s r.o.
 *
 * For the full copyright and licence information, please view
 * the file licence.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing ECLicenceName.
 *
 * @author Vojtech Obrusnik <vojtech.obrusnik@honeywell.com>
 */
interface IECLicenceNameMapper
{
	/**
	 * Saves ECLicenceName.
	 * @param ECLicenceName $licence_name
	 * @return boolean TRUE if operation ended with success, FALSE otherwise.
	 */
	public function save(ECLicenceName $licence_name);
	
	/**
	 * Updates ECLicenceName.
	 * @param ECLicenceName $licence_name
	 * @return boolean TRUE if operation ended with success, FALSE otherwise.
	 */
	public function update(ECLicenceName $licence_name);
	
	/**
	 * Deletes ECLicenceName.
	 * @param int $id ECLicenceName id.
	 * @return boolean TRUE if operation ended with success, FALSE otherwise.
	 */
	public function delete($id);
	
	/**
	 * Finds ECLicenceName by id.
	 * @param int $id EC licence id.
	 * @return ECLicenceName or NULL if not found.
	 */
	public function find($id);
	
	/**
	 * Finds all ECLicenceNames.
	 * @return array Array of ECLicenceName or empty array.
	 */
	public function findAll();
	
	/**
	 * Finds all ECLicenceName by name.
	 * @param string $name
	 * @return ECLicenceName or NULL if not found.
	 */
	public function findByName($name);
}