<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2012 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing project states.
 *
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
interface IProjectStateMapper
{
	/**
	 * Returns project state by its number.
	 * 
	 * @param int $number Project state number.
	 * @return ProjectState or NULL if not found
	 */
	public function find($number);

	/**
	 * Returns all project states as an array sorted by name.
	 * 
	 * @return array of ProjectState
	 */
	public function findAll();

}
