<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2014 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Project - ECLicenceName relation definition.
 *
 * @author Vojtech Obrusnik <vojtech.obrusnik@honeywell.com>
 */
class ProjectECLicenceName extends Object
{	
	/** @var int Project id */
	private $projectID;
	/** @var int ECLicenceName id */
	private $ECLicenceNameID;
	
	/**
     * Sets Project id.
     * @param int $id Must be positive integer.
	 * @throws InvalidArgumentException
     */
	public function setProjectID($id)
	{
		if ($id > 0)
			$this->projectID = $id;
		else
			throw new InvalidArgumentException('Project ID must be integer greater than 0. Wrong param: ' . $id);
	}
	
	/**
     * Gets Project id
     * @return int
     */
	public function getProjectID()
	{
		return $this->projectID;
	}
	
	/**
     * Sets ECLicenceName id.
     * @param int $id Must be positive integer.
	 * @throws InvalidArgumentException
     */
	public function setECLicenceNameID($id)
	{
		if ($id > 0)
			$this->ECLicenceNameID = $id;
		else
			throw new InvalidArgumentException('ECLicenceName ID must be integer greater than 0. Wrong param: ' . $id);
	}
	
	/**
     * Gets ECLicenceName id
     * @return int
     */
	public function getECLicenceNameID()
	{
		return $this->ECLicenceNameID;
	}
}