<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2012 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Represents state of the project.
 *
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
class ProjectState extends Object
{
	/** @var int */
	private $number;

	/** @var string */
	private $name;

	public function __construct($number, $name)
	{
		$this->number = $number;
		$this->name = $name;
	}

    /**
     * Gets project state number.
     * 
     * @return int
     */
	public function getNumber()
	{
		return $this->number;
	}	
	
    /**
     * Gets project state name.
     * 
     * @return string
     */
	public function getName()
	{
		return $this->name;
	}
	
	/**
	 * Gets project state number with project state name e.g. "1: first state"
	 * 
	 * @return string
	 */
	public function getNumberWithName()
	{
		return $this->number . ': ' . $this->name;
	}

}