<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * CustomerProgram definition.
 *
 * @author Vojtech Obrusnik <vojtech.obrusnik@honeywell.com>
 */
class CustomerProgram extends Object
{
	/** @var int ID of program */
	private $programID;
	/** @var int ID of customer */
	private $customerID;
	/** @var string Name of program */
	private $program;
	/** @var string Remarks for program */
	private $remarks;
	
	/**
	 * Sets program ID.
	 * @param int $id Must be positive integer.
	 * @throws InvalidArgumentException
	 */
	public function setProgramID($id)
	{
		if ($id > 0)
			$this->programID = $id;
		else
			throw new InvalidArgumentException('Program ID must be integer greater than 0. Wrong param: ' . $id);
	}
	
	/**
	 * Gets program ID.
	 * @return int
	 */
	public function getProgramID()
	{
		return $this->programID;
	}
	
	/**
     * Sets ID of customer.
     * @param int $id Must be positive integer.
	 * @throws InvalidArgumentException
     */
	public function setCustomerID($id)
	{
		if ($id > 0)
			$this->customerID = $id;
		else
			throw new InvalidArgumentException('Customer ID must be integer greater than 0. Wrong param: ' . $id);
	}
	
    /**
     * Gets ID of customer.
     * @return int
     */
	public function getCustomerID()
	{
		return $this->customerID;
	}
	
	/**
     * Sets program.
     * @param string $name
     */
	public function setProgram($name)
	{
		$this->program = $name;
	}
	
    /**
     * Gets program.
     * @return string
     */
	public function getProgram()
	{
		return $this->program;
	}
	
	/**
     * Sets remarks.
     * @param string $text
     */
	public function setRemarks($text)
	{
		$this->remarks = $text;
	}
	
    /**
     * Gets remarks.
     * @return string
     */
	public function getRemarks()
	{
		return $this->remarks;
	}
}
