<?php

/**
 * This file is part of the ATE Tool - STRAP addon
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing STRAP ItemActivityYearlyBudget.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
interface IItemActivityYearlyBudgetMapper
{
	/**
	 * Saves new STRAP item activity yearl budget.
	 * 
	 * @param ItemActivityYearlyBudget $item
	 * @return boolean
	 */
	public function save(ItemActivityYearlyBudget $item);
	
	/**
	 * Updates existing STRAP ItemActivityYearlyBudget.
	 * 
	 * @param ItemActivityYearlyBudget $item
	 * @return boolean
	 */
	public function update(ItemActivityYearlyBudget $item);
	
	/**
	 * Deletes existing STRAP ItemActivityYearlyBudget.
	 * 
	 * @param int $item_id
	 * @param int $year
	 * @return boolean
	 */
	public function delete($item_id, $year);

	/**
	 * Gets STRAP ItemActivityYearlyBudget by id and year.
	 * 
	 * @param int $item_id
	 * @param int $year
	 * @return ItemActivityYearlyBudget or null if not found
	 */
	public function find($item_id, $year);

	/**
	 * Gets all STRAP ItemActivityYearlyBudget by id.
	 * 
	 * @param int $item_id
	 * @return array Array of ItemActivityYearlyBudget where Activity_ID_Year is key or null if not found.
	 */
	public function findAllByID($item_id);
}
