<?php

/**
 * This file is part of the ATE Tool - STRAP addon
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing STRAP ProductLine.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
interface IProductLineMapper
{
	/**
	 * Saves new STRAP ProductLine.
	 * 
	 * @param ProductLine $productLine
	 * @return boolean
	 */
	public function save(ProductLine $productLine);
	
	/**
	 * Updates existing STRAP ProductLine.
	 * 
	 * @param ProductLine $productLine
	 * @return boolean
	 */
	public function update(ProductLine $productLine);
	
	/**
	 * Deletes existing STRAP ProductLine.
	 * 
	 * @param int $productLine
	 * @return boolean
	 */
	public function delete($productLine);

	/**
	 * Gets STRAP ProductLine.
	 * 
	 * @param int $productLine
	 * @return ProductLine or null if not found
	 */
	public function find($productLine);

	/**
	 * Gets all STRAP ProductLine.
	 * 
	 * @return array Array of ProductLine or null if not found.
	 */
	public function findAll();
}
