<?php

/**
 * This file is part of the ATE Tool - STRAP addon
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * Interface for accessing PursuitRisk.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
interface IPursuitRiskMapper
{
	/**
	 * Saves new PursuitRisk.
	 * 
	 * @param PursuitRisk $pursuitRisk
	 * @return boolean
	 */
	public function save(PursuitRisk $pursuitRisk);
	
	/**
	 * Updates PursuitRisk.
	 * 
	 * @param PursuitRisk $pursuitRisk
	 * @return boolean
	 */
	public function update(PursuitRisk $pursuitRisk);
	
	/**
	 * Deletes existing PursuitRisk.
	 * 
	 * @param int $id PursuitRisk ID 
	 * @return boolean
	 */
	public function delete($id);

	/**
	 * Gets PursuitRisk.
	 * 
	 * @param int $id PursuitRisk id
	 * @return PursuitRisk or null if not found
	 */
	public function find($id);
}
