<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package presenters
 */

/**
 * ItemFilter defines structure to filter STRAP Items.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class ItemFilter extends Object
{
	/** @var string custom eid */
	private $customID;

	/** @var string Item name*/
	private $name;

	/** @var array of int with ID of organization unit*/
	private $responsibleOrgUnitID;
	
	/** @var int TRL*/
	private $targetTRL = 0;
	
	/** @var int TRL year*/
	private $targetTRLYear = 0;
	
	/** @var int Active*/
	private $active = 1;
	
	public function __construct()
	{
	}
	
    /**
     * Sets custom ID.
     * 
     * @param string $id 
     */
	public function setCustomID($id)
	{
		$this->customID = $id;
	}

    /**
     * Gets custom ID.
     * 
     * @return string
     */
	public function getCustomID()
	{
		return $this->customID;
	}
	
    /** 
     * Sets name. 
     *  
     * @param string $name  
     */ 
    public function setName($name) 
    { 
            $this->name = $name; 
    } 

    /** 
     * Gets name. 
     *  
     * @return string 
     */ 
    public function getName() 
    { 
            return $this->name; 
    } 
	
    /**
     * Sets responsible OrgUnit ID.
     * 
     * @param array if OrgUnit IDs$responsibleOrgUnit
     */
	public function setResponsibleOrgUnitID($responsibleOrgUnit)
	{
			$this->responsibleOrgUnitID = $responsibleOrgUnit;
	}

    /**
     * Gets responsible OrgUnit ID.
     * 
     * @return int
     */
	public function getResponsibleOrgUnitID()
	{
		return $this->responsibleOrgUnitID;
	}	
	
    /**
     * Sets target TRL.
     * 
     * @param int $id
     */
	public function setTargetTRL($targetTRL)
	{
		$this->targetTRL = $targetTRL;
	}

    /**
     * Gets target TRL.
     * 
     * @return int
     */
	public function getTargetTRL()
	{
		return $this->targetTRL;
	}	
	
    /**
     * Sets target TRL year ID.
     * 
     * @param $id int
     */
	public function setTargetTRLYear($targetTRLYear)
	{
		$this->targetTRLYear = $targetTRLYear;
	}

    /**
     * Gets target TRL year ID.
     * 
     * @return int
     */
	public function getTargetTRLYear()
	{
		return $this->targetTRLYear;
	}	
	
    /**
     * Sets Active.
     * 
     * @param int $active
     */
	public function setActive($active)
	{
		$this->active = $active;
	}

    /**
     * Gets Active.
     * 
     * @return int
     */
	public function getActive()
	{
		return $this->active;
	}
}
