<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2014 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * TaskPONumber object class.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class TaskPONumber extends Object
{	
	/** @var int ID of record */
	private $TaskPONumberID;
	/** @var int ID of task */
	private $taskID;
	/** @var int */
	private $year;
	/** @var string */
	private $poNumber;
	
	/**
     * Sets ID of TaskPONumberID.
     * @param int $id Must be positive integer.
	 * @throws InvalidArgumentException
     */
	public function setID($id)
	{
		if ($id > 0)
			$this->TaskPONumberID = $id;
		else
			throw new InvalidArgumentException('TaskPONumberID ID must be integer greater than 0. Wrong param: ' . $id);
	}
	
    /**
     * Gets ID of TaskPONumberID.
     * @return int
     */
	public function getID()
	{
		return $this->TaskPONumberID;
	}
	
	/**
     * Sets ID of task.
     * @param int $id Must be positive integer.
	 * @throws InvalidArgumentException
     */
	public function setTaskID($id)
	{
		if ($id > 0)
			$this->taskID = $id;
		else
			throw new InvalidArgumentException('Task ID must be integer greater than 0. Wrong param: ' . $id);
	}
	
    /**
     * Gets ID of task.
     * @return int
     */
	public function getTaskID()
	{
		return $this->taskID;
	}
	
	/**
     * Sets year.
     * @param int $year
	 * @throws InvalidArgumentException
     */
	public function setYear($year)
	{
	    $this->year = $year;
	}
	
    /**
     * Gets year.
     * @return int
     */
	public function getYear()
	{
		return $this->year;
	}
	
	/**
     * Sets PO number.
     * @param string $number
	 * @throws InvalidArgumentException
     */
	public function setPONumber($number)
	{
		if (is_string($number))
			$this->poNumber = $number;
		else
			throw new InvalidArgumentException('PONumber must be string. Wrong param: ' . $number);
	}
	
    /**
     * Gets PO number.
     * @return string
     */
	public function getPONumber()
	{
		return $this->poNumber;
	}
}
