<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2011 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * User specific application setting.
 *
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
class UserSetting extends Object
{

    /** @var boolean */
	private $WBSShowLabourTasksOnly = TRUE;

    /** @var boolean */
	private $WBSShowCurrentYear = TRUE;

    /** @var boolean */
	private $WBSHideFirstWP = TRUE;

    /** @var boolean */
	private $WBSHideAllWP = TRUE;

    /** @var boolean */
	private $WBSHideTasksWithoutEffort = TRUE;

    /** @var boolean */
	private $EXPDecimalMark = TRUE;

    /** @var boolean */
	private $PROOwnSelect = FALSE;
	
	/** @var boolean */
	private $ShowFakeProjects = TRUE;
	
	/** @var boolean */
	private $ShowFakeTasks = TRUE;
	
	public function __construct() 
	{
	}

    /**
     * Sets indication whether labour task should be visible in Project WBS GUI.
     * 
     * @param boolean $enabled
     */
    public function setWBSShowLabourTasksOnly($enabled)
    {
		$this->WBSShowLabourTasksOnly = ($enabled) ? TRUE : FALSE;
    }

    /**
     * Returns indication whether labour task should be visible in Project WBS GUI.
     * 
     * @return boolean
     */
    public function getWBSShowLabourTasksOnly()
    {
        return $this->WBSShowLabourTasksOnly;
    }
	
    /**
     * Sets indication whether Project WBS GUI should setup current year as default.
     * 
     * @param boolean $enabled
     */
    public function setWBSShowCurrentYear($enabled)
    {
		$this->WBSShowCurrentYear = ($enabled) ? TRUE : FALSE;
    }

    /**
     * Returns indication whether Project WBS GUI should setup current year as default.
     * 
     * @return boolean
     */
    public function getWBSShowCurrentYear()
    {
        return $this->WBSShowCurrentYear;
    }
	
    /**
     * @param boolean $enabled
     */
    public function setWBSHideFirstWP($enabled)
    {
		$this->WBSHideFirstWP = ($enabled) ? TRUE : FALSE;
    }

    /**
     * 
     * @return boolean
     */
    public function getWBSHideFirstWP()
    {
        return $this->WBSHideFirstWP;
    }

    /**
     * @param boolean $enabled
     */
    public function setWBSHideAllWP($enabled)
    {
		$this->WBSHideAllWP = ($enabled) ? TRUE : FALSE;
    }

    /**
     * @return boolean
     */
    public function getWBSHideAllWP()
    {
        return $this->WBSHideAllWP;
    }
	
    /**
     * @param boolean $enabled
     */
    public function setWBSHideTasksWithoutEffort($enabled)
    {
		$this->WBSHideTasksWithoutEffort = ($enabled) ? TRUE : FALSE;
    }

    /**
     * @return boolean
     */
    public function getWBSHideTasksWithoutEffort()
    {
        return $this->WBSHideTasksWithoutEffort;
    }

    /**
     * @param boolean $enabled
     */
    public function setEXPDecimalMark($enabled)
    {
		$this->EXPDecimalMark = ($enabled) ? TRUE : FALSE;
    }

    /**
     * @return boolean
     */
    public function getEXPDecimalMark()
    {
        return $this->EXPDecimalMark;
    }

    /**
     * @param boolean $enabled
     */
    public function setPROOwnSelect($enabled)
    {
		$this->PROOwnSelect = ($enabled) ? TRUE : FALSE;
    }

    /**
     * @return boolean
     */
    public function getPROOwnSelect()
    {
        return $this->PROOwnSelect;
    }
	
    /**
     * @param boolean $showFakeProjects
     */
    public function setShowFakeProjects($showFakeProjects)
    {
		$this->ShowFakeProjects = ($showFakeProjects) ? TRUE : FALSE;
    }

    /**
     * @return boolean
     */
    public function getShowFakeProjects()
    {
        return $this->ShowFakeProjects;
    }
	
    /**
     * @param boolean $showFakeTasks
     */
    public function setShowFakeTasks($showFakeTasks)
    {
		$this->ShowFakeTasks = ($showFakeTasks) ? TRUE : FALSE;
    }

    /**
     * @return boolean
     */
    public function getShowFakeTasks()
    {
        return $this->ShowFakeTasks;
    }
}