<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2012 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models\WBS
 */

/**
 * Implementation of RecursiveIterator over WBSTreeElementItem
 *
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
class WBSTreeElementRecursiveIterator implements RecursiveIterator
{
    private $_list;
	private $_iterator;
   
    public function __construct(WBSTreeElementItem $data) {
        $this->_list = $data->getChildren();
		$this->_iterator = $this->_list->getIterator();
    }
   
    public function valid() {
		return $this->_iterator->valid();
    }
   
    public function hasChildren() {
		if ($this->valid())
			return $this->_iterator->current()->hasChildren();
    }
   
    public function next() {
		return $this->_iterator->next();
    }
   
    public function current() 
	{
		return $this->_iterator->current();
    }
   
    public function getChildren() 
	{
		if ($this->valid())
			return new WBSTreeElementRecursiveIterator($this->_iterator->current());
		else
			return NULL;
    }
   
    public function rewind()
	{
		return $this->_iterator->rewind();
	}
   
    public function key()
	{
		return $this->_iterator->key();
    }
}
