<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2011 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package utils
 */

/**
 * ConversionUtils is used for special conversions..
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class ConversionUtils
{
	/**
	 * Converts all object proporties to associative array. 
	 * 
	 * @param Object $object Converted object.
	 * @return array Associative array.
	 */
	public static function ObjectToArray($object) 
	{
		$reflectionClass = new ReflectionClass(get_class($object));
		$array = array();
		foreach ($reflectionClass->getProperties() as $property) 
		{
			$property->setAccessible(true);
			$array[$property->getName()] = $property->getValue($object);
			$property->setAccessible(false);
		}
		return $array;
	}
}
