<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2014 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models\Import
 */

/**
 * Ancestor class of all iASAP access classes
 *
 * @author Vojtech Obrusnik <vojtech.obrusnik@honeywell.com>
 */
class IASAPWrapper extends Object
{
	/** @var DibiConnection connection to database */
	protected $conn;
	/** @var ILogger Logger */
    protected $logger;
	
	/**
	 * @param ILogger $logger
	 */
	public function __construct(ILogger $logger = NULL)
	{
		$this->conn = new DibiConnection(Environment::getConfig('iasap_database'));
		$this->logger = ($logger === NULL) ? (new NullLogger('')) : $logger;
	}
	
	/**
	 * Function renurns correct EID/HID/TID
	 * TID > 3 000 000
	 * HID > 2 000 000
	 * 
	 * @param int $eid
	 * @return string EID
	 */
	protected function repairEID($eid)
	{
		if($eid > 3000000)
		{
			$repairedEID = 'T' . ($eid - 3000000);
		}
		elseif($eid > 2000000)
		{
			$repairedEID = 'H' . ($eid - 2000000);
		}
		else
		{
			$repairedEID = 'E' . (int)$eid;
		}
		return $repairedEID;
	}
}
