<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2012 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package utils\Logging
 */

/**
 * Dummy logger implementation for dropping messages.
 * 
 * Useful when ILogger implementation is required and logging is not
 * necessary.
 * 
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
class NullLogger implements ILogger
{
	
	/**
	 * Drops logged message.
	 * 
	 * @param string $message Message text.
	 * @param mixed $level message level. Default INFO.
	 * @param string $domain domain of logged message (can be used for grouping or filtering later).
	 * @param mixed $context variable logging context (useful for special log parameters).
	 * @return boolean Returns TRUE if message was written.
	 */
    public function log($message, $level = self::INFO, $domain = NULL, $context = NULL)
	{
		return true;
	}
	
}

