<?php

/**
 * This file is part of the HON Tool
 *
 * Copyright (c) 2009, 2016 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package utils
 */

/**
 * Class controls worker task assignment.
 *
 * @author Leos Navratil <leos.navratil@honeywell.com>
 */
class PlanningControl extends AssignmentControl
{
	/**
	 * Constructor immediately runs planning control check.
	 * 
	 * @param Person $person
	 * @param Project $project
	 */
	public function __construct(Person $person, Project $project)
	{
		$this->context = Environment::getContext();
		$this->person = $person;
		$this->project = $project;
		$this->runAssignmentControl();
		if (!$this->assignable)
			$this->message = implode(', ', $this->tempMessageArray) . '. ' . self::FORBIDEN_ASSIGNMENT_FINAL_MESSAGE;
	}
	
	/**
	 * Procedure runs all planning controls.
	 */
	private function runAssignmentControl()
	{
		$this->licenceVsNationalityCheck();
		$this->personStatusCheck();
	}
}