/**
 * Handles blocking and unblocking of UI while download action is running
 */

// Interval for try to run of unblock action
var unblock_ui_check_interval;
// Cookie key of token
var file_download_token_key = 'fileDownloadToken';

/**
 * Blocks UI when download action is triggered
 */
$(document).on('click', '.blockUIForDownload', function (){
	if($(this).parents('form').find('select[required]').length > 0)
	{
		$(this).parents('form').submit();
		if($(this).parents('form').find('.form-control-error').length > 0)
		{
			return false;
		}
	}
    blockUIForDownload();
});

/**
 * Blocks UI and starts checking for unblock based on value of cookie token
 */
function blockUIForDownload()
{
    // Ensure token value is initialized
    $.cookie(file_download_token_key, null);
    
    $.blockUI({
        message: '<h1>Data generation may take up to several seconds. Please wait!</h1>'
    });
    
    unblock_ui_check_interval = window.setInterval(function ()
    {
		var cookie = $.cookie(file_download_token_key);
        if (cookie && cookie !== 'null')
            unblockUIForDownload();
    }, 1000);
}

/**
 * Unblocks UI
 */
function unblockUIForDownload()
{
    window.clearInterval(unblock_ui_check_interval);
    $.cookie(file_download_token_key, null);
    $.unblockUI();
}